/*
 * Created on 16.12.2004
 */
package net.hoopajoo.swingx;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.Action;
import javax.swing.JToggleButton;

/**
 * A special version of JToggleButton to be used with SelectedActions.
 * @author anttix
 */

public class JSelectedButton extends JToggleButton {
    public JSelectedButton (SelectedAction a) {
        super( a );
    }
    protected void configurePropertiesFromAction(Action a) {
        super.configurePropertiesFromAction( a );
        setSelected( ((SelectedAction)a).isSelected() );
    }
    protected PropertyChangeListener createActionPropertyChangeListener(Action a) {
        a.addPropertyChangeListener( super.createActionPropertyChangeListener ( a ));
        
        return new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent evt) {
                if ( evt.getPropertyName().equals( SelectedAction.ACTION_SELECTED ) ) {
                    setSelected( ((Boolean)evt.getNewValue()).booleanValue() );
                }
            }
        };
    }
}